package solutions.bitbadger.documents.common

/**
 * A comparison operator used for fields
 */
enum class Op(val sql: String) {
    /** Compare using equality */
    EQUAL("="),
    /** Compare using greater-than */
    GREATER(">"),
    /** Compare using greater-than-or-equal-to */
    GREATER_OR_EQUAL(">="),
    /** Compare using less-than */
    LESS("<"),
    /** Compare using less-than-or-equal-to */
    LESS_OR_EQUAL("<="),
    /** Compare using inequality */
    NOT_EQUAL("<>"),
    /** Compare between two values */
    BETWEEN("BETWEEN"),
    /** Compare existence in a list of values */
    IN("IN"),
    /** Compare overlap between an array and a list of values */
    IN_ARRAY("??|"),
    /** Compare existence */
    EXISTS("IS NOT NULL"),
    /** Compare nonexistence */
    NOT_EXISTS("IS NULL")
}
