package solutions.bitbadger.documents.common

/**
 * Derive parameter names; each instance wraps a counter to provide names for anonymous fields
 */
class ParameterName {

    private var currentIdx = 0

    /**
     * Derive the parameter name from the current possibly-null string
     *
     * @param paramName The name of the parameter as specified by the field
     * @return The name from the field, if present, or a derived name if missing
     */
    fun derive(paramName: String?): String =
        paramName ?: ":field${currentIdx++}"
}
