package solutions.bitbadger.documents.common.java;

import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;
import solutions.bitbadger.documents.common.Op;

import static org.junit.jupiter.api.Assertions.assertEquals;

/**
 * Unit tests for the `Op` enum
 */
@DisplayName("Java | Common | Op")
final public class OpTest {

    @Test
    @DisplayName("EQUAL uses proper SQL")
    public void equalSQL() {
        assertEquals("=", Op.EQUAL.getSql(), "The SQL for equal is incorrect");
    }

    @Test
    @DisplayName("GREATER uses proper SQL")
    public void greaterSQL() {
        assertEquals(">", Op.GREATER.getSql(), "The SQL for greater is incorrect");
    }

    @Test
    @DisplayName("GREATER_OR_EQUAL uses proper SQL")
    public void greaterOrEqualSQL() {
        assertEquals(">=", Op.GREATER_OR_EQUAL.getSql(), "The SQL for greater-or-equal is incorrect");
    }

    @Test
    @DisplayName("LESS uses proper SQL")
    public void lessSQL() {
        assertEquals("<", Op.LESS.getSql(), "The SQL for less is incorrect");
    }

    @Test
    @DisplayName("LESS_OR_EQUAL uses proper SQL")
    public void lessOrEqualSQL() {
        assertEquals("<=", Op.LESS_OR_EQUAL.getSql(), "The SQL for less-or-equal is incorrect");
    }

    @Test
    @DisplayName("NOT_EQUAL uses proper SQL")
    public void notEqualSQL() {
        assertEquals("<>", Op.NOT_EQUAL.getSql(), "The SQL for not-equal is incorrect");
    }

    @Test
    @DisplayName("BETWEEN uses proper SQL")
    public void betweenSQL() {
        assertEquals("BETWEEN", Op.BETWEEN.getSql(), "The SQL for between is incorrect");
    }

    @Test
    @DisplayName("IN uses proper SQL")
    public void inSQL() {
        assertEquals("IN", Op.IN.getSql(), "The SQL for in is incorrect");
    }

    @Test
    @DisplayName("IN_ARRAY uses proper SQL")
    public void inArraySQL() {
        assertEquals("??|", Op.IN_ARRAY.getSql(), "The SQL for in-array is incorrect");
    }

    @Test
    @DisplayName("EXISTS uses proper SQL")
    public void existsSQL() {
        assertEquals("IS NOT NULL", Op.EXISTS.getSql(), "The SQL for exists is incorrect");
    }

    @Test
    @DisplayName("NOT_EXISTS uses proper SQL")
    public void notExistsSQL() {
        assertEquals("IS NULL", Op.NOT_EXISTS.getSql(), "The SQL for not-exists is incorrect");
    }
}
