package solutions.bitbadger.documents.common

import org.junit.jupiter.api.DisplayName
import org.junit.jupiter.api.Test
import kotlin.test.assertEquals

/**
 * Unit tests for the `Op` enum
 */
@DisplayName("Kotlin | Common | Op")
class OpTest {

    @Test
    @DisplayName("EQUAL uses proper SQL")
    fun equalSQL() {
        assertEquals("=", Op.EQUAL.sql, "The SQL for equal is incorrect")
    }

    @Test
    @DisplayName("GREATER uses proper SQL")
    fun greaterSQL() {
        assertEquals(">", Op.GREATER.sql, "The SQL for greater is incorrect")
    }

    @Test
    @DisplayName("GREATER_OR_EQUAL uses proper SQL")
    fun greaterOrEqualSQL() {
        assertEquals(">=", Op.GREATER_OR_EQUAL.sql, "The SQL for greater-or-equal is incorrect")
    }

    @Test
    @DisplayName("LESS uses proper SQL")
    fun lessSQL() {
        assertEquals("<", Op.LESS.sql, "The SQL for less is incorrect")
    }

    @Test
    @DisplayName("LESS_OR_EQUAL uses proper SQL")
    fun lessOrEqualSQL() {
        assertEquals("<=", Op.LESS_OR_EQUAL.sql, "The SQL for less-or-equal is incorrect")
    }

    @Test
    @DisplayName("NOT_EQUAL uses proper SQL")
    fun notEqualSQL() {
        assertEquals("<>", Op.NOT_EQUAL.sql, "The SQL for not-equal is incorrect")
    }

    @Test
    @DisplayName("BETWEEN uses proper SQL")
    fun betweenSQL() {
        assertEquals("BETWEEN", Op.BETWEEN.sql, "The SQL for between is incorrect")
    }

    @Test
    @DisplayName("IN uses proper SQL")
    fun inSQL() {
        assertEquals("IN", Op.IN.sql, "The SQL for in is incorrect")
    }

    @Test
    @DisplayName("IN_ARRAY uses proper SQL")
    fun inArraySQL() {
        assertEquals("??|", Op.IN_ARRAY.sql, "The SQL for in-array is incorrect")
    }

    @Test
    @DisplayName("EXISTS uses proper SQL")
    fun existsSQL() {
        assertEquals("IS NOT NULL", Op.EXISTS.sql, "The SQL for exists is incorrect")
    }

    @Test
    @DisplayName("NOT_EXISTS uses proper SQL")
    fun notExistsSQL() {
        assertEquals("IS NULL", Op.NOT_EXISTS.sql, "The SQL for not-exists is incorrect")
    }
}
