package solutions.bitbadger.documents.java.java.testDocs;

import kotlinx.serialization.Serializable;
import solutions.bitbadger.documents.java.Document;
import solutions.bitbadger.documents.java.integration.ThrowawayDatabase;

import java.util.List;

import static solutions.bitbadger.documents.java.integration.TypesKt.TEST_TABLE;

@Serializable
public class JsonDocument {

    private String id;
    private String value;
    private int numValue;
    private SubDocument sub;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public int getNumValue() {
        return numValue;
    }

    public void setNumValue(int numValue) {
        this.numValue = numValue;
    }

    public SubDocument getSub() {
        return sub;
    }

    public void setSub(SubDocument sub) {
        this.sub = sub;
    }

    public JsonDocument(String id, String value, int numValue, SubDocument sub) {
        this.id = id;
        this.value = value;
        this.numValue = numValue;
        this.sub = sub;
    }

    public JsonDocument(String id, String value, int numValue) {
        this(id, value, numValue, null);
    }

    public JsonDocument(String id) {
        this(id, "", 0, null);
    }

    private static final List<JsonDocument> testDocuments = List.of(
            new JsonDocument("one", "FIRST!", 0),
            new JsonDocument("two", "another", 10, new SubDocument("green", "blue")),
            new JsonDocument("three", "", 4),
            new JsonDocument("four", "purple", 17, new SubDocument("green", "red")),
            new JsonDocument("five", "purple", 18));

    public static void load(ThrowawayDatabase db, String tableName) {
        for (JsonDocument doc : testDocuments) {
            Document.insert(tableName, doc, db.getConn());
        }
    }

    public static void load(ThrowawayDatabase db) {
        load(db, TEST_TABLE);
    }
}
