package solutions.bitbadger.documents.java.integration

import java.sql.Connection

/**
 * Common interface for PostgreSQL and SQLite throwaway databases
 */
interface ThrowawayDatabase : AutoCloseable {

    /** The database connection for the throwaway database */
    val conn: Connection

    /**
     * Determine if a database object exists
     *
     * @param name The name of the object whose existence should be checked
     * @return True if the object exists, false if not
     */
    fun dbObjectExists(name: String): Boolean
}
