package solutions.bitbadger.documents.java.integration.sqlite

import org.junit.jupiter.api.DisplayName
import org.junit.jupiter.api.assertThrows
import solutions.bitbadger.documents.common.DocumentException
import solutions.bitbadger.documents.java.integration.common.Count
import kotlin.test.Test

/**
 * SQLite integration tests for the `Count` object / `count*` connection extension functions
 */
@DisplayName("Java | Kotlin | SQLite: Count")
class CountIT {

    @Test
    @DisplayName("all counts all documents")
    fun all() =
        SQLiteDB().use(Count::all)

    @Test
    @DisplayName("byFields counts documents by a numeric value")
    fun byFieldsNumeric() =
        SQLiteDB().use(Count::byFieldsNumeric)

    @Test
    @DisplayName("byFields counts documents by a alphanumeric value")
    fun byFieldsAlpha() =
        SQLiteDB().use(Count::byFieldsAlpha)

    @Test
    @DisplayName("byContains fails")
    fun byContainsMatch() {
        assertThrows<DocumentException> { SQLiteDB().use(Count::byContainsMatch) }
    }

    @Test
    @DisplayName("byJsonPath fails")
    fun byJsonPathMatch() {
        assertThrows<DocumentException> { SQLiteDB().use(Count::byJsonPathMatch) }
    }
}
