package solutions.bitbadger.documents.kotlin

import kotlinx.serialization.json.Json

object Configuration {

    /**
     * JSON serializer; replace to configure with non-default options
     *
     * The default sets `encodeDefaults` to `true` and `explicitNulls` to `false`; see
     * https://github.com/Kotlin/kotlinx.serialization/blob/master/docs/json.md for all configuration options
     */
    @JvmField
    var json = Json {
        encodeDefaults = true
        explicitNulls = false
        coerceInputValues = true
    }

    /** The JSON serializer to use for documents */
    @JvmStatic
    var serializer: DocumentSerializer = DocumentSerializerKotlin()

}
